{***************************************************************************}
{                             UNIDAD DE MEMORIA

                                 Copyright (c) 1998 Marco Antonio Alvarado
}
{***************************************************************************}

{$G+}
UNIT UMemoria;

INTERFACE

  FUNCTION SumaPunteroCerca (Puntero : Pointer; MasCampo : Word) : Pointer;
  FUNCTION SumaPunteroLejos (Puntero : Pointer; MasSegmento, MasCampo :
    Word) : Pointer;
  PROCEDURE Intercambia (VAR Valor1, Valor2 : Integer);

IMPLEMENTATION

  FUNCTION SumaPunteroCerca (Puntero : Pointer; MasCampo : Word) : Pointer;
    ASSEMBLER;
  ASM
{Calcula el incremento.}
    MOV CX, MasCampo
    MOV BX, CX
    SHR CX, 4
    AND BX, 15

{Carga la direccin.}
    LES AX, Puntero
    MOV DX, ES

{Incrementa la direccin y la regresa.}
    ADD DX, CX
    ADD AX, BX
  END;

  FUNCTION SumaPunteroLejos (Puntero : Pointer; MasSegmento, MasCampo :
    Word) : Pointer; ASSEMBLER;
  ASM
{Calcula el incremento del Campo.}
    MOV CX, MasCampo
    MOV BX, CX
    SHR CX, 4
    AND BX, 15

{Carga la direccin.}
    LES AX, Puntero
    MOV DX, ES

{Incrementa la direccin y la regresa.}
    ADD DX, MasSegmento
    ADD DX, CX
    ADD AX, BX
  END;

  PROCEDURE Intercambia (VAR Valor1, Valor2 : Integer); ASSEMBLER;
  ASM
    PUSH DS
    LES DI, Valor1
    MOV AX, ES:Word PTR [DI]
    LDS SI, Valor2
    MOV BX, DS:Word PTR [SI]
    XCHG AX, BX
    MOV ES:Word PTR [DI], AX
    MOV DS:Word PTR [SI], BX
    POP DS
  END;

END.